﻿Imports Asgard3.Core.BattleNetClient
Imports System.Drawing
Imports System.Windows.Forms
Imports Asgard3.Core.Plugin

Public Class Main : Implements IPlugin
    Public Host As IHost
    Public ReadOnly Property Filename() As String Implements IPlugin.Filename
        Get
            Return "ExamplePluginVBNET.dll"
        End Get
    End Property
    Public ReadOnly Property URL() As String Implements IPlugin.URL
        Get
            Return "http://www.mikeownage.com/downloads/asgard3/plugins/ExamplePluginVBNET.dll"
        End Get
    End Property
    Public ReadOnly Property Author() As String Implements IPlugin.Author
        Get
            Return "Mike"
        End Get
    End Property
    Public ReadOnly Property Description() As String Implements IPlugin.Description
        Get
            Return "A basic plugin example for asgard3 in VB.NET."
        End Get
    End Property
    Public Sub Unload() Implements IPlugin.Unload
        Host.UnloadPlugin()
    End Sub
    Public Sub Initialize(ByVal hst As IHost) Implements IPlugin.Initialize
        Dim settings As New ConnectionSettings
        settings.username = "Blah"
        settings.warden = WardenType.Internal
        settings.connectiontype = ConnectionType.Hashes
        Dim Client As New BattleNetClient(settings)
        AddHandler Client.HandleBattleNetChatEvents, AddressOf ChatEvent


        Dim myMenu As New ToolStripMenuItem
        Dim e As New EventHandler(AddressOf myMenus_Click)
        myMenu.Text = "ExamplePlugin VB.NET"
        myMenu.DropDownItems.Add(PluginFunctions.NewToolMenu("Test", "Test", e))
        Host = hst
        AddHandler Host.Client.HandleBattleNetChatEvents, AddressOf ChatEvent
        AddHandler Host.Client.HandleSocketData, AddressOf Packets
        Host.SetPluginMenu(myMenu)
        Host.SaveSetting("Color", Color.Green.Name)
        Dim result As Color
        result = Color.FromName(Host.GetSetting("Color"))
        Host.AddChat(Color.Beige, "Example Plugin VB.NET loaded")
    End Sub
    Private Sub myMenus_Click(ByVal sender As Object, ByVal e As EventArgs)
        Dim x As ToolStripMenuItem
        x = sender
        Select Case x.Name
            Case "Test"
                MessageBox.Show("Hello World!")
        End Select
    End Sub
    Private Sub ChatEvent(ByVal evt As BattleNetChatEventID, ByVal ParamArray o() As Object)
        Select Case evt
            Case BattleNetChatEventID.EID_CHANNEL
                Host.Client.EnqueueMessage("Hello world")
        End Select
    End Sub
    Public Sub Packets(ByVal packetid As Byte, ByVal socket As ServiceType, ByVal username As String, ByVal packet As String, ByVal col As Color, ByVal action As SocketAction)
        If socket = ServiceType.BNET Then
            Dim pid As BattleNetPacketID
            pid = packetid
            If action = SocketAction.Receiving Then
                Select Case pid
                    Case BattleNetPacketID.SID_AUTH_CHECK
                        Host.AddChat(Color.Pink, "Auth Check Receiving")
                End Select
            End If
        End If
    End Sub
    Public ReadOnly Property Name() As String Implements IPlugin.Name
        Get
            Return "Example Plugin VB.NET"
        End Get
    End Property
End Class